within ;
package ZtratyTUTOR
  model Prostredi
    //parameter Real venT=25;

    HeatKonektor hin
      annotation (Placement(transformation(extent={{30,-8},{50,12}}),
          iconTransformation(extent={{-100,-10},{-80,10}})));
    Modelica.Blocks.Interfaces.RealInput step "jdu ven" annotation (Placement(
          transformation(extent={{-20,30},{20,70}}), iconTransformation(
          extent={{-20,-20},{20,20}},
          rotation=270,
          origin={60,60})));
  equation
    hin.T = step;
    annotation (Icon(graphics={Rectangle(
            extent={{-80,80},{80,-80}},
            lineColor={0,0,0},
            fillColor={255,255,255},
            fillPattern=FillPattern.Solid), Text(
            extent={{-66,24},{68,-6}},
            lineColor={0,0,0},
            fillColor={255,255,255},
            fillPattern=FillPattern.Solid,
            textString="Enviroment")}), Diagram(graphics));
  end Prostredi;

  connector HeatKonektor
    Real T "teplota";
    flow Real q "tepelny tok";
    annotation (Icon(graphics={Ellipse(
            extent={{-100,100},{100,-100}},
            lineColor={0,0,0},
            fillColor={255,255,170},
            fillPattern=FillPattern.Solid), Ellipse(
            extent={{-28,30},{30,-30}},
            lineColor={0,0,0},
            fillColor={0,0,0},
            fillPattern=FillPattern.Solid)}));
  end HeatKonektor;

  model KondukcniZtraty
    parameter Real konduktance=1;

    HeatKonektor h1
      annotation (Placement(transformation(extent={{-100,0},{-80,20}})));
    HeatKonektor h2
      annotation (Placement(transformation(extent={{80,0},{100,20}})));
  equation
    h1.q=konduktance*(h1.T-h2.T);
    h1.q=-h2.q;
    annotation (Icon(graphics={Rectangle(
            extent={{-80,40},{80,-20}},
            lineColor={0,0,0},
            fillColor={0,0,0},
            fillPattern=FillPattern.Solid)}));
  end KondukcniZtraty;

  model Telo
    parameter Real m=70 "hmotnost";
    parameter Real tepC=4200 "tepelna kapacita";
    parameter Real T0=37 "teplota lidskeho tela";
    parameter Real q0=21 "bazalni metabolismus";
    Real tepleTelo;

    HeatKonektor out
      annotation (Placement(transformation(extent={{60,0},{80,20}}),
          iconTransformation(extent={{60,0},{80,20}})));
    Modelica.Blocks.Interfaces.RealOutput coreT
      annotation (Placement(transformation(extent={{-10,-10},{10,10}},
          rotation=90,
          origin={10,92}), iconTransformation(
          extent={{-10,-10},{10,10}},
          rotation=0,
          origin={30,-90})));
  initial equation
    tepleTelo = T0*m*tepC;
  equation
    der(tepleTelo) =  out.q + q0;
    out.T = tepleTelo/(m*tepC);
    out.T = coreT;

    annotation (Icon(graphics={
          Ellipse(
            extent={{-24,98},{20,52}},
            lineColor={0,0,0},
            fillColor={0,0,0},
            fillPattern=FillPattern.Solid),
          Rectangle(
            extent={{-4,56},{2,-98}},
            lineColor={0,0,0},
            fillColor={0,0,0},
            fillPattern=FillPattern.Solid),
          Rectangle(
            extent={{-42,20},{42,14}},
            lineColor={0,0,0},
            fillColor={0,0,0},
            fillPattern=FillPattern.Solid),
          Rectangle(
            extent={{-22,-92},{20,-98}},
            lineColor={0,0,0},
            fillColor={0,0,0},
            fillPattern=FillPattern.Solid)}), Diagram(graphics));
  end Telo;


  model kuze
    parameter Real m=70 "hmotnost";
    parameter Real tepC=4200 "tepelna kapacita";
    parameter Real T0=37 "teplota lidskeho tela";
    parameter Real q0=0 "bazalni metabolismus";
    Real tepleTelo;

    HeatKonektor out
      annotation (Placement(transformation(extent={{80,-10},{100,10}}),
          iconTransformation(extent={{80,-10},{100,10}})));
  initial equation
    tepleTelo = T0*m*tepC;
  equation
    der(tepleTelo) =  out.q + q0;
    out.T = tepleTelo/(m*tepC);

    annotation (Icon(graphics={Rectangle(
            extent={{-80,80},{80,-80}},
            lineColor={0,0,0},
            fillColor={255,255,255},
            fillPattern=FillPattern.Solid), Text(
            extent={{-44,22},{48,-12}},
            lineColor={0,0,0},
            fillColor={255,255,255},
            fillPattern=FillPattern.Solid,
            textString="Skin")}));
  end kuze;

  model CevniZasobeni
    parameter Real tepC=4200 "tepelna kapacita";

    HeatKonektor h1
      annotation (Placement(transformation(extent={{-100,0},{-80,20}})));
    HeatKonektor h2
      annotation (Placement(transformation(extent={{80,0},{100,20}})));
    Modelica.Blocks.Interfaces.RealInput FL "flow liquid"
      annotation (Placement(transformation(extent={{-20,-20},{20,20}},
          rotation=90,
          origin={0,-40})));
  equation
    h1.q=FL*tepC*(h1.T-h2.T);
    h1.q=-h2.q;
    annotation (Icon(graphics={Rectangle(
            extent={{-80,40},{80,-20}},
            lineColor={0,0,0},
            fillColor={255,255,255},
            fillPattern=FillPattern.Solid), Text(
            extent={{-62,24},{62,-4}},
            lineColor={0,0,0},
            fillColor={255,255,255},
            fillPattern=FillPattern.Solid,
            textString="Veins")}), Diagram(graphics));
  end CevniZasobeni;

  model regulator
    parameter Real CC=1 "constant control";

    Modelica.Blocks.Interfaces.RealInput coreT annotation (Placement(
          transformation(extent={{-100,0},{-60,40}}),   iconTransformation(extent={{-100,0},
              {-60,40}})));
    Modelica.Blocks.Interfaces.RealOutput FC "flow control"
      annotation (Placement(transformation(extent={{80,-40},{100,-20}}),
          iconTransformation(extent={{80,-40},{100,-20}})));
  equation
    (coreT-37)*CC = FC;
    annotation (Icon(graphics={Rectangle(
            extent={{-60,40},{80,-40}},
            lineColor={0,0,0},
            fillColor={255,255,255},
            fillPattern=FillPattern.Solid), Text(
            extent={{-40,40},{60,-40}},
            lineColor={0,0,0},
            fillColor={255,255,255},
            fillPattern=FillPattern.Solid,
            textString="R")}));
  end regulator;




  partial connector SignalBusBlue "Icon for signal bus"

    annotation (
      Icon(coordinateSystem(
          preserveAspectRatio=true,
          extent={{-100,-100},{100,100}},
          grid={2,2},
          initialScale=0.2), graphics={
          Rectangle(
            extent={{-20,2},{20,-2}},
            lineColor={255,204,51},
            lineThickness=0.5),
          Polygon(
            points={{-80,50},{80,50},{100,30},{80,-40},{60,-50},{-60,-50},{
                -80,-40},{-100,30},{-80,50}},
            lineColor={0,0,0},
            fillColor={0,0,255},
            fillPattern=FillPattern.Solid),
          Ellipse(
            extent={{-65,25},{-55,15}},
            lineColor={0,0,0},
            fillColor={0,0,0},
            fillPattern=FillPattern.Solid),
          Ellipse(
            extent={{-5,25},{5,15}},
            lineColor={0,0,0},
            fillColor={0,0,0},
            fillPattern=FillPattern.Solid),
          Ellipse(
            extent={{55,25},{65,15}},
            lineColor={0,0,0},
            fillColor={0,0,0},
            fillPattern=FillPattern.Solid),
          Ellipse(
            extent={{-35,-15},{-25,-25}},
            lineColor={0,0,0},
            fillColor={0,0,0},
            fillPattern=FillPattern.Solid),
          Ellipse(
            extent={{25,-15},{35,-25}},
            lineColor={0,0,0},
            fillColor={0,0,0},
            fillPattern=FillPattern.Solid)}),
      Diagram(coordinateSystem(
          preserveAspectRatio=true,
          extent={{-100,-100},{100,100}},
          grid={2,2},
          initialScale=0.2), graphics={
          Polygon(
            points={{-40,25},{40,25},{50,15},{40,-20},{30,-25},{-30,-25},{-40,
                -20},{-50,15},{-40,25}},
            lineColor={0,0,0},
            fillColor={0,0,255},
            fillPattern=FillPattern.Solid),
          Ellipse(
            extent={{-32.5,7.5},{-27.5,12.5}},
            lineColor={0,0,0},
            fillColor={0,0,0},
            fillPattern=FillPattern.Solid),
          Ellipse(
            extent={{-2.5,12.5},{2.5,7.5}},
            lineColor={0,0,0},
            fillColor={0,0,0},
            fillPattern=FillPattern.Solid),
          Ellipse(
            extent={{27.5,12.5},{32.5,7.5}},
            lineColor={0,0,0},
            fillColor={0,0,0},
            fillPattern=FillPattern.Solid),
          Ellipse(
            extent={{-17.5,-7.5},{-12.5,-12.5}},
            lineColor={0,0,0},
            fillColor={0,0,0},
            fillPattern=FillPattern.Solid),
          Ellipse(
            extent={{12.5,-7.5},{17.5,-12.5}},
            lineColor={0,0,0},
            fillColor={0,0,0},
            fillPattern=FillPattern.Solid),
          Text(
            extent={{-150,70},{150,40}},
            lineColor={0,0,0},
            textString="%name")}),
      Documentation(info="<html>
<p>
This icon is designed for a <b>signal bus</b> connector.
</p>
</html>"));

  end SignalBusBlue;







  annotation (uses(Modelica(version="3.2")));
end ZtratyTUTOR;
